#!/bin/env perl

# Copyright (c) 2014 Daniel Jakots <vigdis@chown.me>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.


use strict;
use warnings;
use Switch;
use feature 'say';
use List::Util qw (shuffle);

my $pad_dir = `pwd`; chomp $pad_dir ; $pad_dir .= "/";

my @membres = ("Apinnet",
	       "Aquilenet", 
	       "Auvernet",
	       "Cafai",
	       "Chaul'Hertz",
	       "Faimaison",
	       "FDN",
	       "Franciliens.net",
	       "Grenode \n\n   Illyse \n\n\n   NDN \n\n\n   Rézine",
	       "Grifon",
	       "Ilico",
	       "Iloth",
	       "Grand est (partie commune ARN et LDN) \n\n   Alsace Réseau Neutre \n \n \n   Lorraine Data Network",
	       "Netopi",
	       "PC Light",
	       "Rhizome",
	       "Sames Wireless",
	       "Sallanches Data Network",
	       "Teleragno",
	       "tetaneutral.net",
	       "Igwan.net",
	       "Aïl-network",
	       "Neutrinet",
	       "TDN"
    );

my @nonmembres = ( "Vianet",
		   "Armagnet",
		   "DRN",
		   "Troyes Télécom"
    );
 


say "Quelle est la date prevue de la reunion ? (format JJ/MM/AAAA)";
my $line= <> ; chomp $line;
my ($jour,$nummois,$annee) = split /\//, $line;
my $mois;
switch ($nummois) {
    case "01" { $mois = "Janvier";}
    case "02" { $mois = "Février"}
    case "03" { $mois = "Mars"}
    case "04" { $mois = "Avril"}
    case "05" { $mois = "Mai"}
    case "06" { $mois = "Juin"}
    case "07" { $mois = "Juillet"}
    case "08" { $mois = "Août"}
    case "09" { $mois = "Septembre"}
    case "10" { $mois = "Octobre"}
    case "11" { $mois = "Novembre"}
    case "12" { $mois = "Décembre"}
}
say "Quel est le lien de la réunion précédente ?";
my $padprecedent= <> ; chomp $padprecedent;

my $filename = $pad_dir."pad-suivi.md";
my $fh;
open ($fh, '>', $filename) or die "Impossible d'ouvrir le fichier $filename en écriture";

say $fh "Le mail à envoyer : ";
say $fh "Bonjour à tou⋅te⋅s,

C’est aujourd’hui que le sondage se finit. La date ayant reçu le plus de
suffrages est :
\tJOUR $jour $mois $annee
\tsur #ffdn-suivi (serveur irc.geeknode.org)
\thttps://pad.ilico.org/p/ffdn-$annee$nummois$jour

Merci de bien remplir le pad et de ne pas le faire à la dernière minute,
c’est pas pratique pour la réunion sinon.";
say $fh "-";
say $fh "Le lien du pad sera https://pad.ilico.org/p/ffdn-$annee$nummois$jour";
say $fh "-";
say $fh "# Réunion de suivi de la Fédération FDN du $jour $mois $annee.";
say $fh "(20h, sur #ffdn-suivi irc://irc.geeknode.org)";
say $fh "";
say $fh "Pad de la réunion précédente : $padprecedent";
say $fh "";
say $fh "## Ordre du jour :";
say $fh "";
say $fh "* Nouvelles des membres";
say $fh "";
say $fh "## Règles de bonne conduite

==============================================================

Les nouvelles d'un membre doivent être écrites dans le pad à l'avance si vous n'avez rien à raconter mettez \"RAS\" pour savoir que ce n'est pas un oubli

Sur IRC, on ne fait que poser les questions relatives au contenu du pad. (les gens sont disponibles en query ou sur #ffdn si vous êtes en retard)

Un seul point à la fois. Quand c'est fini, c'est fini, on ne revient pas en arrière.

Soyons efficaces. Dire « Bonjour », « Désolé, je suis en retard », « J'aime le fromage », c'est très sympa, mais ça dilue le contenu utile. C'est comme rentrer dans une pièce et interrompre tout le monde. Au bout du 3e qui le fait, c'est pénible :)

Une personne est désignée pilote de la réunion, si possible pour toute la durée de la réunion.

Le·a pilote décide quand passer au point suivant. Ille ne le fait qu'après s'être raisonnablement assuré·e que le point courant est terminé.

Si le·a pilote considère qu'une des règles ci-dessus n'est pas respectée, le·e pilote a raison.

Le·a pilote doit donc faire preuve de **discernement**.
 
**Présents** ([prénom,] *pseudo*, [nom,] *asso*, [GA]) Inscrivez-vous **à côté du nom de votre association**.
 
**Désignation du pilote :**

Indiquer en face de votre prénom si vous souhaitez être pilote, et, le cas échéant, sur quelle plage horaire.

==============================================================";
say $fh "";
say $fh "## Les points de l'Ordre du jour abordés";
say $fh "\n";
say $fh "### Nouvelles des membres triés par tirage aléatoire** (avec un *prng* innocent) : ";
say $fh "";
foreach (shuffle @membres)
{
    say $fh "$_ \n\n";
}
say $fh "";
say $fh "#### Les pas (encore) membres : ";
say $fh "";
foreach (shuffle @nonmembres)
{
    say $fh "$_ \n\n";
}

close $fh;

